var handleException = function(e) {
  if (!window.ssbCrashDetails) {
    window.ssbCrashDetails = [];
  }

  window.ssbCrashDetails.push(e);

  if (window.Bugsnag) {
    window.Bugsnag.notifyException(e, "SSB Interop Crash");
  }

  // NB: Most of the exceptions that are thrown in the SSB aren't fatal, they're
  // from 3rd party content. We're just gonna let 'em roll, because JavaScript.
  console.error(e);
  if (window.globalLogger) {
    window.globalLogger.error(e);
  }
};

process.on('uncaughtException', handleException);

var fs = require('fs');
var path = require('path');
var _ = require('lodash');

// Warning: You almost certainly do *not* want to edit this code - instead, you
// want to edit src/ssb/main.js instead
var start = function(loadSettings) {
  window.loadSettings = loadSettings;
  if (loadSettings.devMode) {
    require('electron-compile').init();
  } else {
    var cachePath = path.join(__dirname, '..', 'cache');
    require('electron-compile').initForProduction(cachePath);
  }
  
  var noCommitVersion = loadSettings.version.split('-')[0];
  var shouldSuppressErrors = loadSettings.devMode || loadSettings.testMode;

  window.Bugsnag = require('./bugsnag-2.js');
  require('../src/renderer/bugsnag-setup')(shouldSuppressErrors, noCommitVersion);
  require('../src/ssb/main');
};

try {
  const processRef = window.process;
  process.nextTick(function() { 
    // Patch global back in
    window.process = processRef; 
  });
  
  // NB: For whatever reason, we have to wait longer to restore 'global'
  setTimeout(function() { window.global = window; }, 10);
  
  start(_.extend({}, require('remote').getGlobal('slackApplication').loadSettings));
} catch (e) {
  handleException(e);
}
